section
  name SQL Queries
  t
    | Here are some convenient SQL queries

  figure
    name SQL Queries
    sourcecode(type="SQL")
      | /* list shifters earned points and shifts for given year */
      | SELECT
      |   ASSO_OPER_YEAR AS OPER_YEAR,
      |   ASSO_USER_ID AS USER_ID,
      |   ASSO_INST_ID AS INST_ID,
      |   COUNT(case SHIFT_SHK_KIND when 'shift-leader' then 1 else null end) AS SHIFT_LEADER,
      |   COUNT(case SHIFT_SHK_KIND when 'night' then 1 else null end) AS NIGHT,
      |   COUNT(case SHIFT_SHK_KIND when 'morning' then 1 else null end) AS MORNING,
      |   COUNT(case SHIFT_SHK_KIND when 'afternoon' then 1 else null end) AS AFTERNOON,
      |   SUM(POINT_VALUE) AS POINTS
      |   FROM ASSOCIATIONS
      |     INNER JOIN SHIFTS ON ASSO_ID = SHIFT_ASSO_ID
      |     INNER JOIN POINTS_SHIFTS ON
      |       SHIFT_SHK_KIND = POINT_SHK_KIND AND
      |       ASSO_OPER_YEAR = POINT_OPER_YEAR AND
      |       TO_CHAR(SHIFT_DATE, 'D') = (POINT_DAY_OF_WEEK + 1)
      |   WHERE ASSO_OPER_YEAR = 2011
      |   GROUP BY ASSO_OPER_YEAR, ASSO_USER_ID, ASSO_INST_ID
      |   ORDER BY ASSO_USER_ID;
      |
      |  /* list institute earned points and shifts for given year */
      |  SELECT
      |    ASSO_OPER_YEAR AS OPER_YEAR,
      |    ASSO_INST_ID AS INST_ID,
      |    COUNT(case SHIFT_SHK_KIND when 'shift-leader' then 1 else null end) AS SHIFT_LEADER,
      |    COUNT(case SHIFT_SHK_KIND when 'night' then 1 else null end) AS NIGHT,
      |    COUNT(case SHIFT_SHK_KIND when 'morning' then 1 else null end) AS MORNING,
      |    COUNT(case SHIFT_SHK_KIND when 'afternoon' then 1 else null end) AS AFTERNOON,
      |    SUM(POINT_VALUE) AS POINTS
      |    FROM ASSOCIATIONS
      |      INNER JOIN SHIFTS ON ASSO_ID = SHIFT_ASSO_ID
      |      INNER JOIN POINTS_SHIFTS ON
      |        SHIFT_SHK_KIND = POINT_SHK_KIND AND
      |        ASSO_OPER_YEAR = POINT_OPER_YEAR AND
      |        TO_CHAR(SHIFT_DATE, 'D') = (POINT_DAY_OF_WEEK + 1)
      |  WHERE ASSO_OPER_YEAR = 2010
      |  GROUP BY ASSO_OPER_YEAR, ASSO_INST_ID
      |  ORDER BY ASSO_INST_ID;